#!/bin/bash
# Prefill excel to later fill manually, with all possible data from madrid.es API

TMPDIR=/tmp/apimadrid

INITIALDIR=`pwd`
mkdir -p $TMPDIR
cd $TMPDIR

wget -nv "https://datos.madrid.es/egobfiles/api.datos.madrid.es.json" -O api.json

perl -pe 's/}/\n/g' api.json | grep catalogo | grep formato | perl -pe 's/,"/https:\/\/datos.madrid.es\/egob/g' | perl -pe 's/{formato/dcat/g' > dcats.txt

echo '"URLDCAT";"NAME";"TAG";"VALUE";"DESCRIPTION"' > api.csv

while IFS='' read -r dcats || [[ -n "$dcats" ]]; do
  URLDCAT=$dcats
  wget -nv "$URLDCAT" -O rdf.dcat
  NAME=`grep "dct:title xml" rdf.dcat | grep -v '>Catálogo de datos abiertos del Ayuntamiento de Madrid<' | grep -v '>Consulta el API de datos.madrid.es<' | head -n1 | awk -F '>' '{print $2}' | awk -F '<' '{print $1}' | perl -pe 's/"//g'`
  DESCRIPTION=`grep "description xml" rdf.dcat  | grep CDATA | awk -F '[' '{print $3}' | awk -F ']' '{print $1}' | perl -pe 's/"//g'`
  echo '"'$URLDCAT'";"'$NAME'";"";"";"'$DESCRIPTION'"' >> api.csv
done < dcats.txt

cp api.csv $INITIALDIR && cd $INITIALDIR && echo "api.csv creado! :)"


